package net.sergeych.synctools

@Suppress("EXPECT_ACTUAL_CLASSIFIERS_ARE_IN_BETA_WARNING")
actual class WaitHandle {
    private val access = Object()

    actual fun await(milliseconds: Long): Boolean {
        return synchronized(access) {
            try {
                access.wait(milliseconds)
                true
            }
            catch(_: InterruptedException) {
                false
            }
        }
    }

    actual fun wakeUp() {
        synchronized(access) { access.notifyAll() }
    }
}